# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution  
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import wizard
from osv import osv
import pooler
from osv import fields
import time


def _launch_wizard(self, cr, uid, data, context):
    """
    Search for a wizard to launch according to the type.
    If type is manual, just confirm the order.
    """
    pool = pooler.get_pool(cr.dbname)
    invoice_obj = pool.get('account.invoice')
    order_line = pool.get('payment.line')
    order_ref = pool.get('payment.order')
    order = order_ref.browse(cr, uid, data['id'], context)
    
    t = order.mode and order.mode.type.code or 'manual'
    if t == 'manual':
        order_ref.set_done(cr,uid,data['id'],context)
        return {}
   
    journal_id = order.inter_bank_journal.id
    period_ids = pool.get('account.period').find(cr, uid, context=context)
    for pay_line in order.line_ids:
        invoice_data = invoice_obj.browse(cr, uid, pay_line.move_line_id.invoice.id, context=context)
        if pay_line.cash_discount:
            context.update({'pay_cash_discount': pay_line.cash_discount, 'pay_cash_dis_acc': pay_line.partner_id.property_supplier_cash_discount_account.id})
        account_id = order.inter_bank_journal.default_credit_account_id and order.inter_bank_journal.default_credit_account_id.id
        invoice_obj.pay_and_reconcile(cr, uid, [invoice_data.id],
            pay_line.amount_currency, account_id, period_ids[0], journal_id, False,
            period_ids[0], journal_id, context, pay_line.name)

    gw = order_ref.get_wizard(t)
    if not gw:
        order_ref.set_done(cr, uid, data['id'], context)
        return {}       

    mod_obj = pool.get('ir.model.data')
    act_obj = pool.get('ir.actions.wizard')
    module, wizard = gw
    result = mod_obj._get_id(cr, uid, module, wizard)
    id = mod_obj.read(cr, uid, [result], ['res_id'])[0]['res_id']
    result = act_obj.read(cr, uid, [id])[0]
    return result

class wizard_pay(wizard.interface):

    states= {
        'init' : {
            'actions': [],
            'result': {
                'type': 'action',
                'action': _launch_wizard,
                'state': 'end'
            }
        }
    }
wizard_pay('pay_discount_payment')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
