# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import wizard
import pooler
import time
from datetime import datetime
from dateutil.relativedelta import relativedelta
from mx import DateTime
from tools.translate import _

_next_payment_date_form = '''<?xml version="1.0"?>
<form string="Next Payment Date Calculation">
    <label colspan="2" string="Do you want to recompute Next Payment Date?"/>
</form>''' 

_next_payment_date_fields = {}

def _calculate_next_payment_date(self, cr, uid, data, context):
    pool = pooler.get_pool(cr.dbname)
    invoice_obj = pool.get('account.invoice')
    payment_term_obj = pool.get('account.payment.term')

    current_date = datetime.now().strftime('%Y-%m-%d')
    ids = invoice_obj.search(cr, uid, [('state', '=', 'open')]) 
    for id in ids:
        invoice_data = invoice_obj.browse(cr, uid, id, context=context)
        next_pay_date = invoice_data.next_payment_date
        if invoice_data.payment_term.id:
            payment_data = payment_term_obj.browse(cr, uid, invoice_data.payment_term.id)
        if next_pay_date: 
            if next_pay_date < current_date:
                for dis_line in payment_data.cash_discount_ids:
                    discount_date = (DateTime.strptime(invoice_data.date_invoice, '%Y-%m-%d') + DateTime.RelativeDateTime(days = dis_line.delay)).strftime('%Y-%m-%d')
                    if discount_date > current_date:
                        self.write(cr, uid, [id], {'next_payment_date': discount_date})
    return {}

class wiz_next_payment_date(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {
                'type': 'form',
                'arch':_next_payment_date_form,
                'fields':_next_payment_date_fields,
                'state': [('calculate', 'Yes'), ('end', 'No')]
            }
        },
        'calculate': {
            'actions': [],
            'result': {
                'type': 'action',
                'action': _calculate_next_payment_date,
                'state': 'end'
            }
        }
    }
wiz_next_payment_date('cal_next_payment_date')


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

